<th:block class="openapi" xmlns:th="http://www.thymeleaf.org">
<th:block th:each="entry : ${tags}">
### [(${entry.tag.description}?:${entry.tag.name})]

<th:block th:each="item : ${entry.operations}">
#### [(${item.operation.summary})]
[(${item.operation.description})]

```
[(${item.method})] [(${item.path})]
```
<th:block th:if="${item.operation.requestBody}" th:with="body = ${item.operation.requestBody}">
##### [(#{Request body})]
[(${body.description})]
    <th:block th:each="content : ${body.content}">
\* [(#{**`{0}`** content of(${content.key})})]
<th:block th:include="::schema(${content.value.schema})" />
    </th:block>
</th:block>
<th:block th:if="${item.operation.parameters}">
    <th:block th:include="::parameters(title='Header', params=${item.operation.parameters.{? getIn() == 'header'}})" />
    <th:block th:include="::parameters(title='Path', params=${item.operation.parameters.{? getIn() == 'path'}})" />
    <th:block th:include="::parameters(title='Query', params=${item.operation.parameters.{? getIn() == 'query'}})" />
</th:block>

<th:block th:if="${item.operation.responses}">
##### [(#{'Response(s)'})]
    <th:block th:each="response : ${item.operation.responses}">
###### `[(${response.key})]` : [(${response.value.description})]
        <th:block th:if="${response.value.headers}">
| [(#{Header})]     | [(#{Description})]       | [(#{Type})]              | [(#{Example})] |
| ----------------- | ------------------------ | ------------------------ | -------------- |
<th:block th:each="header : ${response.value.headers}">| `[(${header.key})]` | [(${header.value.description})] | [(${header.value.schema.type})] | `[(${header.value.schema.example})]` |
</th:block>
        </th:block>
        <th:block th:each="content : ${response.value.content}">
\* [(#{**`{0}`** content(${content.key})})]
<th:block th:if="${content.value.schema}"
>[(#{of})] <th:block th:include="::schema(${content.value.schema})" />
</th:block>
            <th:block th:if="${content.value.example}">
_{+Value+}_ :
```[(${content.key == 'application/json' ? 'json' : ''})]
[(${content.value.example})]
```
            </th:block>
            <th:block th:each="example : ${content.value.examples}">
=> _{+[(${example.key})]+}_
[(${example.value.summary ? ': ' + example.value.summary : null})]
[(${example.value.description})]
                <th:block th:if="${example.value.value}">
_{+Value+}_ :
```
[(${example.value.value})]
```
                </th:block>
            </th:block>
        </th:block>
    </th:block>
</th:block>
</th:block>
</th:block>

### [(#{Components})]
#### [(#{Objects})]
<th:block th:each="schema : ${api.components.schemas}">
##### [(#{Object `{0}`(${schema.key})})]
<th:block th:include="::objectSchema(${schema.value})" />
</th:block>

<th:block th:fragment="parameters(title, params)">
    <th:block th:if="${!#lists.isEmpty(params)}">
##### [(#{${title + ' parameter(s)'}})]
| [(#{Name})]       | [(#{Required})]       | [(#{Description})]       | [(#{Type})]              | [(#{Default value})] | [(#{Example})] |
| ----------------- | :-------------------: | ------------------------ | ------------------------ | -------------------- | -------------- |
<th:block th:each="p : ${params}">| `[(${p.name})]` | [(${p.required} ? 'Yes' : 'No')] | [(${p.description})] | [(${p.schema.type})] |               | `[(${p.example})]` |
</th:block>
    </th:block>
</th:block>

<th:block th:fragment="schema(schema)"
    ><th:block th:if="${schema != null}"
        ><th:block th:if="${schema instanceof io.swagger.v3.oas.models.media.ArraySchema}">[(#{collection of})] <th:block th:include="::schema(${schema.items})" /></th:block
        ><th:block th:unless="${schema instanceof io.swagger.v3.oas.models.media.ArraySchema}"
            ><th:block th:if="${schema.properties}"
>[(${object})]

| [(#{Property})] | [(#{Type})] | [(#{Description})] |
| --------------- | ----------- | ------------------ |
<th:block th:each="property : ${schema.properties}"
>| [(${property.key})] | <th:block th:include="::schema(${property.value})" /> | [(${property.value.description})] |
</th:block
            ></th:block
            ><th:block th:unless="${schema.properties}"
                ><th:block th:if="${schema.get$ref()}" th:with="ref = ${schema.get$ref().replaceFirst('^.*/', '')}">[(#{object type})] [ #[(${ref})] ](#[(#{object})]-[(${ref.toLowerCase()})])</th:block
                ><th:block th:unless="${schema.get$ref()}">[(${schema.type})]</th:block
            ></th:block
        ></th:block
    ></th:block
></th:block>


<th:block th:fragment="objectSchema(schema)"
    ><th:block th:if="${schema != null}"
        ><th:block th:if="${schema instanceof io.swagger.v3.oas.models.media.ArraySchema}">[(#{collection of})] <th:block th:include="::schema(${schema.items})" /></th:block
        ><th:block th:unless="${schema instanceof io.swagger.v3.oas.models.media.ArraySchema}"
            ><th:block th:if="${schema.properties}"
>[(${schema.description})]

| [(#{Property})] | [(#{Type})] | [(#{Description})] |
| --------------- | ----------- | ------------------ |
<th:block th:each="property : ${schema.properties}"
>| [(${property.key})] | <th:block th:include="::objectSchema(${property.value})" /> | [(${property.value.description})] |
</th:block
            ></th:block
            ><th:block th:unless="${schema.properties}"
                ><th:block th:if="${schema.get$ref()}" th:with="ref = ${schema.get$ref().replaceFirst('^.*/', '')}">[(#{object type})] [ #[(${ref})] ](#object-[(${ref.toLowerCase()})])</th:block
                ><th:block th:unless="${schema.get$ref()}">[(${schema.type})]</th:block
            ></th:block
        ></th:block
    ></th:block
></th:block>
